//Sample using LiquidCrystal library
#include <LiquidCrystal.h>
#include <Time.h> 
 
/*******************************************************
 
This program will test the LCD panel and the buttons
Mark Bramwell, July 2010
 
********************************************************/
//Занятые входы  
//A0, - кнопки на экране
//A12,A13,A14 - Заняты сенсорами влажности
//D17 - Лампа
//D18 - Помпа 0
//D19 - Помпа 1
//D20 - Помпа 2
//D12 - speaker
//D4,D5,D6,D7,D8,D9 - Заняты экраном
// select the pins used on the LCD panel
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);
int speaker=12; //PIN звука
String MenuPunkt0[2] = {"Settings", "Start work"};
String MenuPunkt1[7] = {"Set Time", "Set Sound", "Set Pomp 1", "Set Pomp 2", "Set Pomp 3", "Set Lamp", "Return"};
String MenuPunkt2[3] = {"Hours", "Minuts", "Return"};
String MenuPunkt3[3] = {"Sound ON", "Sound OFF", "Return"};
String MenuPunkt5[4] = {"OFF","Work by shed.", "Work by humi.", "Return"};

String MenuPunkt7[5] = {"Every 1 day", "Every 2 day", "Every 7 day", "Every month", "Return"};
String MenuPunkt8[4] = {"10 sec.", "15 sec.", "20 sec.", "Return"};
String MenuPunkt9[3] = {"Time ON", "Time OFF", "Return"};
int maxPunktMemu[10] = {2,7,3,3,0,4,3,5,4,3};
int maxkolpunkt=0;
boolean IsConfig = true; // Мы в конфигурации?

boolean isDebug = true;

boolean isSound = true;
boolean isFirst=true;
int posMenu = 0; //выбранная Позиция в меню.
int startPos=0; //Стартовая позиция при прорисовке меню
int nUnitworkBy[3] = {0,0,0}; //режим работы 0 - OFF 1 -по расписанию, 2 - по влажности
int nUnitShed[3] = {1,1,1}; //Расписание 1= 1 раз в день 2= 1 раз в 2 дня, 7 = 1 раз в 7 дней, 30 = 1 раз в месяц 
int nPomp[3] = {18,19,20}; //ПИНЫ Помп
int nLampPin = 21; //Пин Лампы
long startTimer[3]={0,0,0};

int nHumidity[3] = {650,650,650}; //Показатель влажности пороговый
int nCurHumidity[3] = {0,0,0};
int nMinutON=0; //минуты включения света
int nHourON=7; //время включения света
int nMinutOFF=0; //минуты включения света
int nHourOFF=22; //время включения света
String cM = "0";
int nUnitNumber;
boolean isWatering[3]= {false,false,false};
boolean isLampON = false;
// define some values used by the panel and buttons
int lcd_key     = 0;
int adc_key_in  = 0;
#define btnRIGHT  0
#define btnUP     1
#define btnDOWN   2
#define btnLEFT   3
#define btnSELECT 4
#define btnNONE   5


// read the buttons
int read_LCD_buttons()
{
 adc_key_in = analogRead(0);      // read the value from the sensor 
 // my buttons when read are centered at these valies: 0, 144, 329, 504, 741
 // we add approx 50 to those values and check to see if we are close
 if (adc_key_in > 1000) return btnNONE; // We make this the 1st option for speed reasons since it will be the most likely result
 if (adc_key_in < 50)   return btnRIGHT;  
 if (adc_key_in < 195)  return btnUP; 
 if (adc_key_in < 380)  return btnDOWN; 
 if (adc_key_in < 555)  return btnLEFT; 
 if (adc_key_in < 790)  return btnSELECT;   
 return btnNONE;  // when all others fail, return this...
}
 
void Menu(String levelMenu, int selectPos) {
if (isDebug) {  Serial.print("nUnitNumber:"); Serial.println(nUnitNumber);}
if (levelMenu=="0") {
      // statements
      
   
      maxkolpunkt=0;//Указатель на индек в массиве максимальных значений меню
      for (int i=0; i <= 1; i++)
      {
        lcd.setCursor(0,i);
        if (selectPos == i) {lcd.print('\x7E'+MenuPunkt0[i]);} else {lcd.print(' '+MenuPunkt0[i]);}
      }
       //Задержка при первом входе в меню, нужна для того чтобы отпустить палец
       if (isFirst==true) {delay(1000); isFirst=false;}
} 

if (levelMenu=="00") { // меню settings
    maxkolpunkt=1; //Указатель на индек в массиве максимальных значений меню
  //   Serial.print("startPos:"); Serial.println(startPos);
   //  Serial.print("selectPos:"); Serial.println(selectPos);
    for (int i=0; i <= 1; i++)      
      {
        lcd.setCursor(0,i); 
        if (selectPos-startPos == i) {lcd.print('\x7E'+MenuPunkt1[i+startPos]);} else {lcd.print(' '+MenuPunkt1[i+startPos]);}
      }
} 
 if (levelMenu=="000") { // меню Time
    maxkolpunkt=2; //Указатель на индек в массиве максимальных значений меню
    for (int i=0; i <= 1; i++)      
      {
        lcd.setCursor(0,i); 
          if (selectPos-startPos == i) {
          if (MenuPunkt2[i+startPos]=="Hours") {lcd.print('\x7E'+MenuPunkt2[i+startPos]+": "+String(hour()));}
          if (MenuPunkt2[i+startPos]=="Minuts") {lcd.print('\x7E'+MenuPunkt2[i+startPos]+": "+minute());}
          if (MenuPunkt2[i+startPos]=="Return") {lcd.print('\x7E'+MenuPunkt2[i+startPos]);}
      } else {
        if (MenuPunkt2[i+startPos]=="Hours") {lcd.print(' '+MenuPunkt2[i+startPos]+": "+hour());}
        if (MenuPunkt2[i+startPos]=="Minuts") {lcd.print(' '+MenuPunkt2[i+startPos]+": "+minute());}
        if (MenuPunkt2[i+startPos]=="Return") {lcd.print(' '+MenuPunkt2[i+startPos]);}
      }
      }
}
if (levelMenu=="0000") { // меню Часы
    maxkolpunkt=2; //Указатель на индек в массиве максимальных значений меню
       lcd.setCursor(0,0);
       lcd.print("Use UP/DOWN/Enter");
       lcd.setCursor(0,1);
       lcd.print(hour());
} 
 if (levelMenu=="0001") { // меню Минуты
    maxkolpunkt=2; //Указатель на индек в массиве максимальных значений меню
       lcd.setCursor(0,0);
       lcd.print("Use UP/DOWN/Enter");
       lcd.setCursor(0,1);
       lcd.print(minute());
} else if (levelMenu=="001") { // меню sound
    maxkolpunkt=3; //Указатель на индек в массиве максимальных значений меню
    for (int i=0; i <= 1; i++)      
      {
        lcd.setCursor(0,i); 
           if (selectPos-startPos == i) {lcd.print('\x7E'+MenuPunkt3[i+startPos]);} else {lcd.print(' '+MenuPunkt3[i+startPos]);}
           if (isSound&&(MenuPunkt3[i+startPos]=="Sound ON")) {lcd.print("  *");}
           if (!isSound&&(MenuPunkt3[i+startPos]=="Sound OFF")) {lcd.print(" *");}
      }
}  
 if ((levelMenu=="002")||(levelMenu=="003")||(levelMenu=="004")) { // меню режима работы по расписанию или по влажности
    maxkolpunkt=5; //Указатель на индек в массиве максимальных значений меню
    for (int i=0; i <= 1; i++)      
      {
        lcd.setCursor(0,i); 
           if (selectPos-startPos == i) {lcd.print('\x7E'+MenuPunkt5[i+startPos]);} else {lcd.print(' '+MenuPunkt5[i+startPos]);}
           if ((nUnitworkBy[nUnitNumber]==0)&&(MenuPunkt5[i+startPos]=="OFF")) {lcd.print(" *");}
           if ((nUnitworkBy[nUnitNumber]==1)&&(MenuPunkt5[i+startPos]=="Work by shed.")) {lcd.print(" *");}
           if ((nUnitworkBy[nUnitNumber]==2)&&(MenuPunkt5[i+startPos]=="Work by humi.")) {lcd.print(" *");}
         }
} 
if ((levelMenu=="0021")||(levelMenu=="0031")||(levelMenu=="0041")) { // меню режима работы  по влажности
nUnitworkBy[nUnitNumber]=1;
    maxkolpunkt=7; //Указатель на индек в массиве максимальных значений меню
    for (int i=0; i <= 1; i++)      
      {
        lcd.setCursor(0,i); 
           if (selectPos-startPos == i) {lcd.print('\x7E'+MenuPunkt7[i+startPos]);} else {lcd.print(' '+MenuPunkt7[i+startPos]);}
           if ((nUnitShed[nUnitNumber]==1)&&(MenuPunkt7[i+startPos]=="Every 1 day")) {lcd.print(" *");}
           if ((nUnitShed[nUnitNumber]==2)&&(MenuPunkt7[i+startPos]=="Every 2 day")) {lcd.print(" *");}
           if ((nUnitShed[nUnitNumber]==7)&&(MenuPunkt7[i+startPos]=="Every 7 day")) {lcd.print(" *");}
           if ((nUnitShed[nUnitNumber]==30)&&(MenuPunkt7[i+startPos]=="Every month")) {lcd.print(" *");}
         }
} 
if ((levelMenu=="0022")||(levelMenu=="0032")||(levelMenu=="0042")) { // меню Влажность
nUnitworkBy[nUnitNumber]=2;
    maxkolpunkt=2; //Указатель на индек в массиве максимальных значений меню
       lcd.setCursor(0,0);
       lcd.print("Use UP/DOWN/Enter");
       lcd.setCursor(0,1);
       lcd.print(String(nHumidity[nUnitNumber]));
} 

if (levelMenu=="005") { // меню режима работы лампы
    maxkolpunkt=9; //Указатель на индек в массиве максимальных значений меню
    for (int i=0; i <= 1; i++)      
      {
        lcd.setCursor(0,i); 
           if (selectPos-startPos == i) {lcd.print('\x7E'+MenuPunkt9[i+startPos]);} else {lcd.print(' '+MenuPunkt9[i+startPos]);}
         }
} else if ((levelMenu=="0050")||(levelMenu=="0051"))  { // меню часы минуты для лампы
    for (int i=0; i <= 1; i++)      
      {
        lcd.setCursor(0,i); 
           if (selectPos-startPos == i) {lcd.print("\x7E"+String( MenuPunkt2[i+startPos]));} else {lcd.print(" "+String(MenuPunkt2[i+startPos]));}
         }
} 
if (levelMenu=="00500") { // меню часы 
    maxkolpunkt=2; //Указатель на индек в массиве максимальных значений меню
       lcd.setCursor(0,0);
       lcd.print("Use UP/DOWN/Enter");
       lcd.setCursor(0,1);
       lcd.print(String(nHourON));
} else if (levelMenu=="00501") { // меню минуты
    maxkolpunkt=2; //Указатель на индек в массиве максимальных значений меню
       lcd.setCursor(0,0);
       lcd.print("Use UP/DOWN/Enter");
       lcd.setCursor(0,1);
       lcd.print(String(nMinutON));
} else if (levelMenu=="00510") { // меню часы минуты
    maxkolpunkt=2; //Указатель на индек в массиве максимальных значений меню
       lcd.setCursor(0,0);
       lcd.print("Use UP/DOWN/Enter");
       lcd.setCursor(0,1);
       lcd.print(String(nHourOFF));
} else if (levelMenu=="00511") { // меню минуты
    maxkolpunkt=2; //Указатель на индек в массиве максимальных значений меню
       lcd.setCursor(0,0);
       lcd.print("Use UP/DOWN/Enter");
       lcd.setCursor(0,1);
       lcd.print(String(nMinutOFF));
}
}



void  MenuMinus()
{
 cM=cM.substring(0,cM.length()-1);
posMenu=0;
  startPos=0;
}

void  PushKey (int lcd_key) 
{
    if (isDebug) {  Serial.print("cM:"); Serial.println(cM);}
 switch (lcd_key)               // Выбираем действия по нажатой клавише.
 {
   case btnRIGHT: //Нажата кнопка в право
     {
      lcd.clear();
      cM=cM+posMenu; 
      Serial.print("Menu plus: "); Serial.println(posMenu);
      Serial.print("New cM: "); Serial.println(cM);
      if (cM=="01") {IsConfig=false;} //если пошли в режим работа отменяем режим настроек
      //проверяем каким устройством управляем
           if (cM=="002") {nUnitNumber=0;} //Устройство 1         
           if (cM=="003") {nUnitNumber=1;} //Устройство 2
           if (cM=="004") {nUnitNumber=2;} //Устройство 3
         

       //проверка на return 
      if ((cM=="006")||(cM=="0002")||(cM=="00000")||(cM=="00010")||(cM=="0012")||(cM=="0023")||(cM=="0033")||(cM=="0043")||(cM=="00214")||(cM=="00314")||(cM=="00414")) {
        MenuMinus();  MenuMinus();} 
      if ((cM=="002113")||(cM=="003113")||(cM=="004113")||(cM=="00220")||(cM=="00320")||(cM=="00420")||(cM=="0052")||(cM=="00502")||(cM=="00502")||(cM=="00512")) {
        MenuMinus();  MenuMinus();} 
      if ((cM=="005000")||(cM=="005010")||(cM=="005100")||(cM=="005110")) {
        MenuMinus();  MenuMinus();} 
       // Включаю Звук
      if (cM=="0010") {isSound=true; MenuMinus();}
       // Вывкючаю звук
      if (cM=="0011") {isSound=false; MenuMinus();}
     // нажатие на OFF в режиме работы помп
    if ((cM=="0020")||(cM=="0030")||(cM=="0040")) {
        nUnitworkBy[nUnitNumber]=0;
        MenuMinus();  MenuMinus(); 
      }
     if ((cM=="00210")||(cM=="00310")||(cM=="00410")) { //Обработка графика полива
     nUnitShed[nUnitNumber]=1;MenuMinus(); }
      if ((cM=="00211")||(cM=="00311")||(cM=="00411")) { //Обработка графика полива
     nUnitShed[nUnitNumber]=2;MenuMinus(); }
      if ((cM=="00212")||(cM=="00312")||(cM=="00412")) { //Обработка графика полива
     nUnitShed[nUnitNumber]=7;MenuMinus(); }
      if ((cM=="00213")||(cM=="00313")||(cM=="00413")) { //Обработка графика полива
     nUnitShed[nUnitNumber]=30;MenuMinus(); }
////обработка времени включения и выключения лампы


//         }
      startPos=0;
      posMenu=0;
      delay(300); 
  //   lcd.print("RIGHT ");
     break;
     
     }
  
   case btnUP:
     {
        if (cM=="0000") {adjustTime(60*60);}
        else if (cM=="0001") {adjustTime(60);}
        else if ((cM=="0022")||(cM=="0032")||(cM=="0042")){nHumidity[nUnitNumber]=nHumidity[nUnitNumber]+10;}
        else if (cM=="00500"){ 
                         nHourON++;
                         if (nHourON==24) {nHourON=0;}
                         } 
        else if (cM=="00501"){ 
                         nMinutON++;
                         if (nMinutON==60) {nMinutON=0;}
                         }
        else if (cM=="00510"){ 
                         nHourOFF++;
                         if (nHourOFF==24) {nHourOFF=0;}
                         }
        else if (cM=="00511"){ 
                         nMinutOFF++;
                         if (nMinutOFF==60) {nMinutOFF=0;}
       }else {
              posMenu = posMenu--;
              if (posMenu<0) {posMenu=0;} //не уходим в минус
              if (posMenu>0){startPos--;} //уменьшаем стартовую позицию меню
       }
     delay(300);
     lcd.clear();
   //  lcd.print("UP    ");
     break;
     }
   case btnDOWN: //Кнопка вниз
     {
       if (cM=="0000") {
                         adjustTime(-60*60);
       } else if (cM=="0001"){ 
                         adjustTime(-60);
       } else if ((cM=="0022")||(cM=="0032")||(cM=="0042")){ 
                         nHumidity[nUnitNumber]=nHumidity[nUnitNumber]-10;
       }else if (cM=="00500"){ 
                         nHourON--;
                         if (nHourON==-1) {nHourON=23;}
       }else if (cM=="00501"){ 
                         nMinutON--;
                         if (nMinutON==-1) {nMinutON=59;}
       } else if (cM=="00510"){ 
                         nHourOFF--;
                         if (nHourOFF==-1) {nHourOFF=23;}
       }else if (cM=="00511"){ 
                         nMinutOFF--;
                         if (nMinutOFF==-1) {nMinutOFF=59;}
       } else {
     posMenu = posMenu++; //Выбранная позиция в меню
    
     if (posMenu>maxPunktMemu[maxkolpunkt]-1) {posMenu=maxPunktMemu[maxkolpunkt]-1;} //Не уходим ниже последнего пункта меню
          else 
          {if (posMenu>1){startPos++;}} //При нажатии на кнопку вниз увеличиваем стартовую позицию меню при прорисовке
        }
       delay(300);
       lcd.clear();
       break;
   }
//     case btnNONE:
//     {
//     lcd.print("NONE  ");
//     break;
//     }

 }
}

void Musik() {
tone(speaker, 700, 300);
delay(600);
tone(speaker, 700, 300);
delay(600);
tone(speaker, 780, 150);
delay(300);
tone(speaker, 700, 150);
delay(300);
tone(speaker, 625, 450);
delay(600);
tone(speaker, 590, 150);
delay(300);
tone(speaker, 520, 150);
delay(300);
tone(speaker, 460, 450);
delay(600);
tone(speaker, 350, 450);
delay(600);
delay(600);
tone(speaker, 350, 450);
delay(600);
tone(speaker, 460, 450);
delay(600);
tone(speaker, 520, 150);
delay(300);
tone(speaker, 590, 150);
delay(300);
tone(speaker, 625, 450);
delay(600);
tone(speaker, 590, 150);
delay(300);
tone(speaker, 520, 150);
delay(300);
tone(speaker, 700, 1350);
delay(1800);
tone(speaker, 700, 300);
delay(600);
tone(speaker, 700, 300);
delay(600);
tone(speaker, 780, 150);
delay(300);
tone(speaker, 700, 150);
delay(300);
tone(speaker, 625, 450);
delay(600);
tone(speaker, 590, 150);
delay(300);
tone(speaker, 520, 150);
delay(300);
tone(speaker, 460, 450);
delay(600);
tone(speaker, 350, 450);
delay(600);
delay(600);
tone(speaker, 350, 450);
delay(600);
tone(speaker, 625, 450);
delay(600);
tone(speaker, 590, 150);
delay(300);
tone(speaker, 520, 150);
delay(300);
tone(speaker, 700, 450);
delay(600);
tone(speaker, 590, 150);
delay(300);
tone(speaker, 520, 150);
delay(300);
tone(speaker, 460, 1350);
}


void Work()
{
  int i;
  //Пробегаемся по устройствам
   for (i=0; i <= 2; i++)  {
     //читаем не нажалили кнопку
     lcd.clear();
     if (read_LCD_buttons()==btnRIGHT ) {cM=""; IsConfig=true;isFirst=true;}
     lcd.setCursor(0,0); 
    lcd.print(String(hour())+":"+minute()+' '); lcd.print("Pomp "+String(i+1));
    lcd.setCursor(0,1); 
    if (nUnitworkBy[i]==0) //если устройство выключено
    {
       lcd.print("OFF");
    } 
    if (nUnitworkBy[i]==1) // Если устройство работает по расписанию
    {
      lcd.print("Shed."); //Пишем по расписанию
    switch (nUnitShed[i]) {
    case 1:
      lcd.print("Every 1 day");
      break;
    case 2:
      lcd.print("Every 2 day");
      break;
    case 7:
      lcd.print("Every 7 day");
      break;
    case 30:
      lcd.print("Every 30 day");
      break;
    }
      //Пока поливаем в 10 часов утра
       //  if (isDebug) { Serial.print("Now: "); Serial.println(now());}
       if (hour()==10) //если время = 10 часов то поливаем, но проверяем не полилили мы уже
         {
           if (isDebug) { Serial.print("Time for watering: "); Serial.println(hour());}
           if (!isWatering[i]) {
             if (isDebug) { Serial.print("ON POMP: "); Serial.println(i);}
             startTimer[i]=now()+(60*60*24*nUnitShed[i]);
             Poliv(i);
             isWatering[i]=true;}
          } else {
          if (now()>startTimer[i]){
          isWatering[i]=false;}} //если время не равно 10 то сбпасываем признак политости
   } //конец работы по расписанию
   
    if (nUnitworkBy[i]==2) // Если устройство работает по Влажности
    {
    nCurHumidity[i]=ReadHum(i);  
    lcd.print("Hum:"+String(nHumidity[i])); //Пишем по влажности  
    lcd.print(" Cur="+String(nCurHumidity[i]));
    if (nCurHumidity[i]<=nHumidity[i]) {Poliv(i);} //если влажность меньше заданеной то включаем полив
    } //конец работы по влажности
    
    delay(3000);
   } //Конец Цикла    
   //ПРоверяем лампу
   if (isDebug) { Serial.print("t1 "); Serial.println(((nHourON*60)+nMinutON));}
   if (isDebug) { Serial.print("tn "); Serial.println(((hour()*60)+minute()));}
    if (isDebug) { Serial.print("tn "); Serial.println(((hour()*60)+minute()));}
   
   if (((nHourON*60)+nMinutON)<=((nHourOFF*60)+nMinutOFF))//Проверка на то что время включения меньше времени выключения
     {
       if(((nHourON*60)+nMinutON)<((hour()*60)+minute())&((hour()*60)+minute())<((nHourOFF*60)+nMinutOFF)) 
         {
           digitalWrite(nLampPin, HIGH);
           isLampON=true;
         } else {
         digitalWrite(nLampPin, LOW);
           isLampON=false;
         }
     } else if(((nHourOFF*60)+nMinutOFF)<((hour()*60)+minute())&((hour()*60)+minute())<((nHourON*60)+nMinutON)) 
         {
           digitalWrite(nLampPin, LOW);
           isLampON=false;
         } else {
         digitalWrite(nLampPin, HIGH);
           isLampON=true;
         }
  // if ((hour()==nHourON)&(minute()>=nMinutON)&!isLampON)
  
}
 
void Poliv(int Pomp)
{
  if (isSound) {Musik();}
   if (isDebug) { Serial.print("Start watering, Pomp pin: "); Serial.println(nPomp[Pomp]);}
      digitalWrite(nPomp[Pomp], HIGH);
      delay(15*1000); //льем 10 секунд
   if (isDebug) { Serial.print("Stop watering, Pomp pin: "); Serial.println(nPomp[Pomp]);}
      digitalWrite(nPomp[Pomp], LOW);
}
 
int ReadHum(int hum) //процедура чтения влажности 
{
  int Value;
    switch (hum) {
    case 0:
      Value = analogRead(A12);
      //do something when var equals 1
      break;
    case 1:
       Value = analogRead(A13);
      //do something when var equals 2
      break;
    case 2:
       Value = analogRead(A14);
       break;
    }
 return Value;
}
 
void setup()
{
  int i;
 lcd.begin(16, 2);              // start the library
 lcd.setCursor(0,0);
 lcd.print(""); // print a simple message
 if (isDebug) {Serial.begin(9600);}
 setTime(0,00,00,01,01,2012);
 
   pinMode(nPomp[0], OUTPUT); 
   pinMode(nPomp[1], OUTPUT); 
   pinMode(nPomp[2], OUTPUT);
   pinMode(speaker, OUTPUT);
   pinMode(nLampPin, OUTPUT);
   digitalWrite(speaker, LOW);
   for (i=0; i <= 2; i++)  {digitalWrite(nPomp[i], LOW);}
   digitalWrite(nLampPin, LOW); 
   
 Menu(cM, posMenu); //Рисуем первое меню
 

}
  

  
  
void loop()
{
//  delay(100);
if (IsConfig) {
  
 lcd_key=read_LCD_buttons();
 if (lcd_key!=btnNONE) {
 PushKey(lcd_key); //Обработка нажатия кнопки
 Menu(cM, posMenu);
 }
} else {
  Work();
}
 
// 

// 
}
